Package com.io7m.cedarbridge.schema.ast

# Record Class CBASTProtocolVersion

java.lang.Object
java.lang.Record
com.io7m.cedarbridge.schema.ast.CBASTProtocolVersion

Record Components:
  `userData` - The user data
  `lexical` - The lexical info
  `version` - The version
  `typesAdded` - The types added in this protocol version
  `typesRemoved` - The types removed in this protocol version
  `typesRemovedAll` - All types from the previous version should be removed

All Implemented Interfaces:
  `CBASTDeclarationType`, `CBASTElementType`, `com.io7m.jlexing.core.LexicalType<URI>`

public record CBASTProtocolVersion(CBASTMutableUserData userData, com.io7m.jlexing.core.LexicalPosition<URI> lexical, BigInteger version, List<CBASTTypeName> typesAdded, List<CBASTTypeName> typesRemoved, boolean typesRemovedAll) extends Record implements CBASTDeclarationType
A protocol version declaration.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CBASTProtocolVersion(CBASTMutableUserData userData, com.io7m.jlexing.core.LexicalPosition<URI> lexical, BigInteger version, List<CBASTTypeName> typesAdded, List<CBASTTypeName> typesRemoved, boolean typesRemovedAll)`
  A protocol version declaration.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `com.io7m.jlexing.core.LexicalPosition<URI>`
  `lexical()`
  Returns the value of the `lexical` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.
  `List<CBASTTypeName>`
  `typesAdded()`
  Returns the value of the `typesAdded` record component.
  `List<CBASTTypeName>`
  `typesRemoved()`
  Returns the value of the `typesRemoved` record component.
  `boolean`
  `typesRemovedAll()`
  Returns the value of the `typesRemovedAll` record component.
  `CBASTMutableUserData`
  `userData()`
  Returns the value of the `userData` record component.
  `BigInteger`
  `version()`
  Returns the value of the `version` record component.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### CBASTProtocolVersion

    public CBASTProtocolVersion(CBASTMutableUserData userData, com.io7m.jlexing.core.LexicalPosition<URI> lexical, BigInteger version, List<CBASTTypeName> typesAdded, List<CBASTTypeName> typesRemoved, boolean typesRemovedAll)
    A protocol version declaration.
    Parameters:
      `userData` - The user data
      `lexical` - The lexical info
      `version` - The version
      `typesAdded` - The types added in this protocol version
      `typesRemoved` - The types removed in this protocol version
      `typesRemovedAll` - All types from the previous version should be removed

- ## Method Details

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. Reference components are compared with `Objects::equals(Object,Object)`; primitive components are compared with '=='.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### userData

    public CBASTMutableUserData userData()
    Returns the value of the `userData` record component.
    Specified by:
      `userData` in interface `CBASTElementType`
    Returns:
      the value of the `userData` record component

  - ### lexical

    public com.io7m.jlexing.core.LexicalPosition<URI> lexical()
    Returns the value of the `lexical` record component.
    Specified by:
      `lexical` in interface `CBASTElementType`
    Specified by:
      `lexical` in interface `com.io7m.jlexing.core.LexicalType<URI>`
    Returns:
      the value of the `lexical` record component

  - ### version

    public BigInteger version()
    Returns the value of the `version` record component.
    Returns:
      the value of the `version` record component

  - ### typesAdded

    public List<CBASTTypeName> typesAdded()
    Returns the value of the `typesAdded` record component.
    Returns:
      the value of the `typesAdded` record component

  - ### typesRemoved

    public List<CBASTTypeName> typesRemoved()
    Returns the value of the `typesRemoved` record component.
    Returns:
      the value of the `typesRemoved` record component

  - ### typesRemovedAll

    public boolean typesRemovedAll()
    Returns the value of the `typesRemovedAll` record component.
    Returns:
      the value of the `typesRemovedAll` record component